<?php
class SGAntiVirus_SQL_scanner
{
	public function DetectCMS()
	{
        if (file_exists(SCAN_PATH.'wp-config.php') && file_exists(SCAN_PATH.'wp-includes'.DIRSEP.'version.php')) return 'wordpress';
        if (file_exists(SCAN_PATH.'configuration.php') && file_exists(SCAN_PATH.'administrator'.DIRSEP.'index.php')) return 'joomla';
        
        return 'other';
    }
    
	public function GetSQLsettings($cms = '')
	{
        $a = array(
            'sql_server' => '',
            'sql_database' => '',
            'sql_username' => '',
            'sql_password' => '',
            'prefix' => ''
        );
        
        switch ($cms)
        {
            case 'wordpress':
                $config_file = SCAN_PATH.'wp-config.php';
                if (file_exists($config_file))
                {
                    $config_data = file($config_file);
            		$config_php_code = '';
            		foreach ($config_data as $row)
            		{
            		    $row = trim($row);
            			if (stripos($row, "table_prefix") !== false) 
            			{ 
            				$config_php_code .= $row."\n";
            				break;
            			}
            			else {
							$tmps = stripos($row, "define");
                            if ($tmps !== false && $tmps == 0) $config_php_code .= $row."\n";
                        }
            		}
            		eval($config_php_code);
                    if (defined('DB_NAME')) $a['sql_database'] = DB_NAME;
                    if (defined('DB_USER')) $a['sql_username'] = DB_USER;
                    if (defined('DB_PASSWORD')) $a['sql_password'] = DB_PASSWORD;
                    if (defined('DB_HOST')) $a['sql_server'] = DB_HOST;
                    if (isset($table_prefix)) $a['prefix'] = $table_prefix;
                }
                break;
                
            case 'joomla':
                $config_file = SCAN_PATH.'configuration.php';
                if (file_exists($config_file))
                {
                    if (!class_exists('JConfig'))
                    {
                        include_once($config_file);
                    }
                    if (class_exists('JConfig'))
                    {
                        $db = new JConfig();
                        $a['sql_server'] = $db->host;
                        $a['sql_username'] = $db->user;
                        $a['sql_password'] = $db->password;
                        $a['sql_database'] = $db->db;
                        $a['prefix'] = $db->dbprefix;
                    }
                }
                break;
                
            default: 
        }
        
        return $a;
    }
    
	public function ScanSQLContent($domain, $sql_settings = array(), $cms = '')
	{
        $a = array();
        
   	    if ($sql_settings['sql_username'] == '' || $sql_settings['sql_password'] == '' || $sql_settings['sql_database'] == '') return array('status' => false, 'reason' => 'Empty SQL settings '.print_r($sql_settings, true));;
        
        if (function_exists("mysqli_connect") === false)
        {
            $a = array('status' => false, 'reason' => "mysqli_connect is absent");
            return $a;
        }
			
        $i_connect = mysqli_connect($sql_settings['sql_server'], $sql_settings['sql_username'], $sql_settings['sql_password'], $sql_settings['sql_database']);
        
        if ($i_connect) 
        {
            if ($cms == 'wordpress') $query = "SELECT ID, post_content AS val_data FROM ".$sql_settings['prefix']."posts";
            if ($cms == 'joomla') $query = "SELECT ID, introtext AS val_data FROM ".$sql_settings['prefix']."content";

            $result = self::SQL_query($i_connect, $query );
            if ($result === false)
            {
                $a = array('status' => false, 'reason' => mysqli_error($i_connect));
                return $a;
            }

    		while ($r = mysqli_fetch_array($result))
    		{
                $post_content = "<html><body>".$r['val_data']."</body></html>";
                
                $html = str_get_html($post_content);


                if ($html !== false)
                {
                    $tmp_a = array();
                    
                    // Tag A
                    foreach($html->find('a') as $e) 
                    {
                        $link = strtolower(trim($e->href));
                        if (strpos($link, $domain) !== false) continue;     // Skip own links
                        if (strpos($link, "mailto:") !== false) continue;
                        if (strpos($link, "callto:") !== false) continue;
                        if ( $link[0] == '?' ) continue;
                        if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' && $link[0] != '/' && $link[1] != '/' ) continue;
                        
                        $a['results']['A'][$link] = strip_tags($e->outertext);
                    }
                    
                    
                    
                    // Tag IFRAME
                    foreach($html->find('iframe') as $e) 
                    {
                        $link = strtolower(trim($e->src));
                        if (strpos($link, $domain) !== false) continue;     // Skip own links
                        if ( $link[0] == '?' ) continue;
                        if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' && $link[0] != '/' && $link[1] != '/' ) continue;
                        
                        $a['results']['IFRAME'][$link] = $link;
                    }
                    
                    
                    
                	// Tag SCRIPT
                	foreach($html->find('script') as $e)
                	{
                	    if (isset($e->src)) 
                        {
                            $link = strtolower(trim($e->src));
                        
                            if (strpos($link, $domain) !== false) continue;     // Skip own links
                            if ( $link[0] == '?' ) continue;
                            if ( $link[0] != 'h' && $link[1] != 't' && $link[2] != 't' && $link[3] != 'p' && $link[0] != '/' && $link[1] != '/' ) continue;
                            
                            $t_code = md5($link);
                            $t = $link;
                        }
                        else  {
                            $t_code = md5($e->innertext);
                            $t = substr($e->innertext, 0, 255);
                        }
                        
                        $a['results']['SCRIPT'][$t_code] = $t;
                    }
                
                    unset($html);
                }
            }
            $a['status'] = true;
            if (count($a['results']['A'])) ksort($a['results']['A']);
            if (count($a['results']['IFRAME'])) sort($a['results']['IFRAME']);
            if (count($a['results']['SCRIPT'])) sort($a['results']['SCRIPT']);
        }
        else $a = array('status' => false, 'reason' => 'Cant connect to SQL '.print_r($sql_settings, true));
        
        return $a;
    }
    
    public function SQL_query($con, $sql)
    {
        $a = @mysqli_query($con, $sql);
    
        if ($e = mysqli_errno($con)) return false;
    
        return $a;
    }
}