<?php

function checkServerSettings($return_error_names = false)
{
	$error_name = array();
	$error = 0;
	
	// Check tmp folder is writable
    if (strtoupper(substr(PHP_OS, 0, 3)) !== 'WIN')
    { 
    	if (!is_writable(SCAN_PATH))
    	{
    		chmod ( SCAN_PATH.'/' , 0777 ); 
    		if (!is_writable(SCAN_PATH.'/'))
    		{
    			$error = 1;
    			$error_name[] = 'tmp is not writable';
    		}
    	}
    }
	
	
	if ($return_error_names) return $error_name;
	if ($error == 1) return false;
	else return true;
}

function PrintResultOutput($msg, $type = false) // false = error, true - ok
{
    if ($type)
    {
        // Success
        if (is_array($msg))
        {
        	$a = $msg;
			$a['status'] = 'ok';
        }
        else {
        	$a = array(
            	'status' => 'ok',
            	'msg' => $msg
        	);
       	}
    } 
    else {
        // Error
        if (is_array($msg))
        {
        	$a = $msg;
			$a['status'] = 'error';
        }
        else {
        	$a = array(
            	'status' => 'error',
            	'msg' => $msg
        	);
       	}
    }
    
    echo json_encode($a);
}

function GetDomain()
{
    if(isset($_GET['domain']) && !empty($_GET['domain'])) {
        return $_GET['domain'] . '.' . DOMAIN;
    } else {
        exit("Cant get domain. Contact Siteguarding support team");
    }
    
}

function GetLicenseInfo($domain, $access_key)
{
	$link = SITEGUARDING_SERVER.'?action=licenseinfo&type=json&data=';
	
    $data = array(
		'domain' => $domain,
		'access_key' => $access_key,
		'product_type' => 'server'
	);
    $link .= base64_encode(json_encode($data));
    
    
    $msg = GetRemote_file_contents($link);
    if ($msg === false)
    {
        $link = str_replace("http://", "https://", $link);
        $msg = GetRemote_file_contents($link);
    }
    
    if ($msg == '' || $msg === false) return false;
    
    $a = (array)json_decode($msg, true);
    
    if ($a === false || count($a) == 0) return false;
}


function scan()
{
    $domain = GetDomain();
    
    $license_info = GetLicenseInfo(DOMAIN, ACCESS_KEY); 
    
    if ($license_info === false) die('License error'."\n\n");
    
        
    $scanner = new SGAntiVirus_scanner();
    
    $scanner->antivirus_version = SCRIPT_VERSION;
    $scanner->antivirus_platform = ANTIVIRUS_PLATFORM;
    
    $scanner->license_info = $license_info;
    
    $scanner->work_dir = SCAN_PATH;
    $scanner->tmp_dir = SCAN_PATH;

    $scanner->scan_path = SCAN_PATH;
    $scanner->access_key = ACCESS_KEY;
    $scanner->domain = $domain;
    $scanner->email = REPORT_EMAIL;
    $scanner->session_report_key = md5(SCAN_PATH.time().ACCESS_KEY.mt_rand());
    
    $scanner->scanner();
}

function GetRemote_file_contents($url, $post_data = array(), $parse = false)
{
    if (extension_loaded('curl')) 
    {
        $ch = curl_init();
        
        $postvars = '';
        foreach($post_data as $key => $value) 
        {
            $postvars .= $key . "=" . $value . "&";
        }
        
        curl_setopt($ch, CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.9; rv:38.0) Gecko/20100101 Firefox/38.0");
        curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
        curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        
        if (count($post_data) > 0)
        {
            curl_setopt($ch,CURLOPT_POST, 1);
            curl_setopt($ch,CURLOPT_POSTFIELDS, $postvars);
        }

        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10); // 10 sec
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 10000); // 10 sec
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        
        $output = trim(curl_exec($ch));
        curl_close($ch);
        
        if ($output === false || trim($output) == '')  return false;
        
        if ($parse === true) $output = (array)json_decode($output, true);
        
        return $output;
    }
    else return false;
}

function CreateRemote_file_contents($url, $dst)
{
    $a = CreateRemote_file_contents_ext($url, $dst);
    
    if ($a === false || $a == 0) 
    {
        if (stripos($url, "http://") !== false)
        {
            $url = str_replace("http://", "https://", $url);
            $a = CreateRemote_file_contents_ext($url, $dst);
        }
    }
    
    return $a;
}

function CreateRemote_file_contents_ext($url, $dst)
{
    if (extension_loaded('curl')) 
    {
        $dst = fopen($dst, 'w');
        
        $ch = curl_init();
        
        curl_setopt($ch, CURLOPT_URL, $url );
        curl_setopt($ch, CURLOPT_USERAGENT, "Mozilla/5.0 (Macintosh; Intel Mac OS X 10.9; rv:38.0) Gecko/20100101 Firefox/38.0");
        curl_setopt($ch, CURLOPT_TIMEOUT, 3600);
        curl_setopt($ch, CURLOPT_TIMEOUT_MS, 3600000);
        curl_setopt($ch, CURLOPT_FILE, $dst);
        curl_setopt($ch, CURLOPT_FAILONERROR, true);
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 30); // 30 sec
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT_MS, 30000); // 30 sec
        curl_setopt($ch, CURLOPT_BINARYTRANSFER, 1);
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);
        
        $a = curl_exec($ch);
        if ($a === false)  return false;
        
        $info = curl_getinfo($ch);
        
        curl_close($ch);
        fflush($dst);
        fclose($dst);
        
        return $info['size_download'];
    }
    else return false;
}