<?php
require_once('config.php');
require_once('classes/SGAV_html_parser.php');
require_once('classes/SGAntiVirus_SQL_scanner.php');
require_once('classes/ZipSGAVP.php');
require_once('classes/SGAntiVirus_scanner.php');
require_once('functions.php');

//Init
date_default_timezone_set('Europe/London');
ini_set('max_execution_time',7200);
set_time_limit ( 7200 );
ini_set('post_max_size', '256M');
ini_set('upload_max_filesize', '256M');
ini_set('memory_limit', '512M');
ignore_user_abort(true);

if(isset($_GET['scan_path']) && !empty($_GET['scan_path'])) {
    $scan_path = $_GET['scan_path'];
}

if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {	
        define('DIRSEP', '\\');
        $scan_path = $scan_path.DIRSEP;
    }
    else {
        define('DIRSEP', '/');
        $scan_path = DIRSEP.$scan_path.DIRSEP;
    }
    
$scan_path = str_replace( DIRSEP.DIRSEP, DIRSEP, $scan_path );
define('SCAN_PATH', $scan_path);

$email = ''; 
define('REPORT_EMAIL', $email);

$result = checkServerSettings(true);
if (count($result) > 0 || $result === false)
{
	PrintResultOutput($result, false);	
}

if(isset($_GET['task']) && $_GET['task'] === "scan") {
    scan();
    exit;
}

$actual_link = (isset($_SERVER['HTTPS']) ? "https" : "http") . '://' . $_SERVER['HTTP_HOST']. ':' . $_SERVER['SERVER_PORT'] . $_SERVER['REQUEST_URI'];
$api_link = str_replace('cgi/siteguarding_antivirus_scanner/siteguarding_antivirus_scanner.php', '',$actual_link);
$accounts_link = $api_link . "json-api/get_domain_info?api.version=1";

?>
<html>
    <head>
        <title>Siteguarding Antivirus Scanner</title>
        <meta charset='utf-8'>
        <meta name='viewport' content='width=device-width, initial-scale=1'>
        <link rel="stylesheet" href="css/semantic.min.css">
        <link rel="stylesheet" href="css/siteguarding.css">
        <script type="text/javascript" src="js/jquery.js"></script>
        <script type="text/javascript" src="js/main.js"></script>
        <script type="text/javascript" >
        var access_key = '<?php echo ACCESS_KEY ?>';
        var siteguarding_server = '<?php echo SITEGUARDING_SERVER ?>';
            get_json_data('<?php echo $accounts_link;?>');
        </script>
    </head>
    <body>
        <div class="right_text"><b>Do you have any ideas how to improve this extension?</b> &nbsp&nbsp <a href="https://www.siteguarding.com/en/contacts" target="_blank" class="ui primary button">Contact us</a></div>
        <div class="ui bulleted list"><h3 class="ui header">Here is the list of malware types what our scanner can detect:</h3>
            <div class="item"><b>MySQL and JavaScript injections</b></div>
            <div class="item"><b>Website Defacements</b></div>
            <div class="item"><b>Hidden iFrames</b></div>
            <div class="item"><b>PHP Mailers</b></div>
            <div class="item"><b>Social Engineering Attacks</b></div>
            <div class="item"><b>Phishing Page Detection</b></div>
            <div class="item"><b>Redirects</b></div>
            <div class="item"><b>Website Backdoors</b></div>
            <div class="item"><b>Website Anomalies</b></div>
            <div class="item"><b>Drive-by-Downloads</b></div>
            <div class="item"><b>IP Cloaking</b></div>
            <div class="item"><b>Cross Site Scripting (XSS)</b></div>
            <div class="item"><b>.htaccess</b></div>
        </div>
        <table class="ui celled padded table" id="general">
            <caption><h1 class="ui header">List of accounts</h1></caption>
            <thead>
              <tr>
                 <th>Username</th>
                 <th>Domains & addon domains & subdomains</th>
                 <th>Actions</th>
              </tr>
             </thead>
             <tbody>  
             </tbody>
        <table>
    </body>
</html>

