<?php
class SGAntiVirus_scanner
{
    public static  $scanner_version = '3.0';
    public static  $debug = false;
    
	public static  $bool_list = array(0 => 'FALSE', 1 => 'TRUE');
	
	public static $SITEGUARDING_SERVER = 'https://www.siteguarding.com/ext/antivirus/index.php';
    
    var $antivirus_version = '';
    var $antivirus_platform = '';
    var $antivirus_cms = '';
    
    var $work_dir = '';
    var $tmp_dir = '';
    var $membership = '';
    var $scan_path = '';
    var $access_key = '';
    var $domain = '';
    var $email = '';
    var $session_report_key = '';
    
    var $detected_cms = '';
    var $sql_server = '';
    var $sql_database = '';
    var $sql_username = '';
    var $sql_password = '';
    
    var $full_scan = false;
    
    
    var $exclude_folders_real = array();
    
    var $license_info = array();
    
    public static $max_filesize = 1024000;  // in bytes
    
    
    
	public function AntivirusFinished()
	{
	    if (self::$debug) self::DebugLog('line');
        
	    $reason = error_get_last();
        if (self::$debug) self::DebugLog(print_r($reason, true));
		if (self::$debug) self::DebugLog('PHP process has been terminated');
		
		$fp = fopen($this->tmp_dir.'flag_terminated.tmp', 'w');
		$a = date("Y-m-d H:i:s")." Terminated";
		fwrite($fp, $a);
		fclose($fp);
        
        if ($reason['type'] == 1) echo 'Error: '.$reason['message'].' File: '.$reason['message'].' Line: '.$reason['line'];	
	}


	
	public function AntivirusFileLock()
	{
	    $lockFile = $this->tmp_dir.'antivirus_scan.lock';
		
		$lockFp = fopen($lockFile, 'w');
		
		flock($lockFp, LOCK_UN);
		unlink($lockFile);
	}
    


    
	public function scanner($check_session = true, $show_results = true)
	{
	    // Start scanning process
        error_reporting(0);
		ini_set('memory_limit', '512M');
        
        if (!defined('DIRSEP')) 
        {
    	    if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') define('DIRSEP', '\\');
    		else define('DIRSEP', '/');
        }
        
        
		// Skip the 2nd scan process
		$lockFile = $this->tmp_dir.'antivirus_scan.lock';
		
		if (file_exists($lockFile) && (time() - filemtime($lockFile)) < 60*2)
		{
			$error_msg = 'Another Scanning Process in the memory. Try again in few minutes. Exit.';
			if (self::$debug) self::DebugLog($error_msg);
			exit;
		}
		
		register_shutdown_function('self::AntivirusFileLock');
		
		$lockFp = fopen($lockFile, 'w');
        
        // Register any shutdown of the script
        register_shutdown_function('self::AntivirusFinished');
        
		$error_msg = 'Start Scan Process ver. '.$this->antivirus_version.' [scanner ver. '.self::$scanner_version.']';
		if (self::$debug) self::DebugLog($error_msg, true);
		
		
        
        
        // Set some constants
        if (!defined('DEBUG_FLAG')) define('DEBUG_FLAG', false);
        if (!defined('DEBUG_FILELIST')) define('DEBUG_FILELIST', false);
        if (!defined('CALLBACK_PACK_FILE')) define('CALLBACK_PACK_FILE', false);
        if (!defined('SCAN_SQL')) define('SCAN_SQL', true);
        if (!defined('FULL_SCAN')) define('FULL_SCAN', $this->full_scan);
        

	
		$tmp_result = set_time_limit ( 7200 );
		
		$error_msg = 'Change Time limit: '.self::$bool_list[intval($tmp_result)].' , Value: '.ini_get('max_execution_time');
		if (self::$debug) self::DebugLog($error_msg);
		
		$error_msg = 'Current Memory limit: '.ini_get('memory_limit');
		if (self::$debug) self::DebugLog($error_msg);

		$error_msg = 'OS info: '.PHP_OS.' ('.php_uname().')';
		if (self::$debug) self::DebugLog($error_msg);
		
		$error_msg = 'PHP ver: '.PHP_VERSION;
		if (self::$debug) self::DebugLog($error_msg);
		
		if (file_exists($this->tmp_dir.'flag_terminated.tmp')) unlink($this->tmp_dir.'flag_terminated.tmp');
        if (file_exists($this->tmp_dir.'filelist_'.md5($this->access_key).'.txt')) unlink($this->tmp_dir.'filelist_'.md5($this->access_key).'.txt');
		
		// Remove old version logs
		if (file_exists($this->tmp_dir.'filelist.txt')) unlink($this->tmp_dir.'filelist.txt');
		if (file_exists($this->tmp_dir.'debug.log')) unlink($this->tmp_dir.'debug.log');
		if (file_exists($this->tmp_dir.'pack.zip')) unlink($this->tmp_dir.'pack.zip');
		if (file_exists($this->tmp_dir.'pack.tar')) unlink($this->tmp_dir.'pack.tar');
		if (file_exists($this->tmp_dir.'report_excluded_folders.php')) unlink($this->tmp_dir.'report_excluded_folders.php');
		if (file_exists($this->tmp_dir.'report_excluded_files.php')) unlink($this->tmp_dir.'report_excluded_files.php');
		if (file_exists($this->tmp_dir.'report_notreadable_files.php')) unlink($this->tmp_dir.'report_notreadable_files.php');
		if (file_exists($this->tmp_dir.'antivirus_error.log')) unlink($this->tmp_dir.'antivirus_error.log');
		if (file_exists($this->tmp_dir.'report_sql_results.php')) unlink($this->tmp_dir.'report_sql_results.php');
        
        $SCAN_SQL = SCAN_SQL;
        if (self::$debug)
        {
            if ($SCAN_SQL === true) $error_msg = 'SCAN_SQL: true';
            else $error_msg = 'SCAN_SQL: false';
            self::DebugLog($error_msg);
        }
        
        
        
        
		// Some Init data
		$membership = 'pro';
		$scan_path = $this->scan_path; 
		$access_key = $this->access_key;
		$domain = $this->domain;
		$email = $this->email;
		$session_report_key = $this->session_report_key; 
		
			// Some logs
			$error_msg = 'Domain: '.$domain;
			if (self::$debug) self::DebugLog($error_msg);
			
			$error_msg = 'Scan path: '.$scan_path;
			if (self::$debug) self::DebugLog($error_msg);
			
			$error_msg = 'Session report key: '.$session_report_key;
			if (self::$debug) self::DebugLog($error_msg);
            
			$error_msg = 'Report URL: https://www.siteguarding.com/antivirus/viewreport?report_id='.$session_report_key;
			if (self::$debug) self::DebugLog($error_msg);
			
			$error_msg = 'TMP folder: '.$this->tmp_dir;
			if (self::$debug) self::DebugLog($error_msg);
            
            

        
        if (file_exists($this->tmp_dir.'antivirus_sql.lock')) 
        {
            $error_msg = 'Lock file: antivirus_sql.lock';
            if (self::$debug) self::DebugLog($error_msg);
            
            $SCAN_SQL = false;
            
            if ( (time() - filectime($this->tmp_dir.'antivirus_sql.lock')) > 14*24*60*60)   // 14days
            {
                unlink($this->tmp_dir.'antivirus_sql.lock');
                $SCAN_SQL = true;
            }
        }
            
        if ($SCAN_SQL)
        {
            // Get CMS
            $detected_CMS = SGAntiVirus_SQL_scanner::DetectCMS();
            
            $error_msg = 'Detected CMS: '.$detected_CMS;
            if (self::$debug) self::DebugLog($error_msg);
            
            if ($detected_CMS == 'other')
            {
                $SCAN_SQL = false;
                $error_msg = 'SCAN_SQL: turned OFF [reason: unsupported CMS]';
                if (self::$debug) self::DebugLog($error_msg);
            }
        }
		


		
		/**
		 * Analyze SQL
		 */
        if ($SCAN_SQL) 
        {
            $error_msg = 'Start SQL scan';
            if (self::$debug) self::DebugLog($error_msg);
            
            $fp = fopen($this->tmp_dir.'antivirus_sql.lock', 'w');
            fwrite($fp, '0');
            fclose($fp);
            
            // Get database settings
            $error_msg = 'Get SQL settings';
            if (self::$debug) self::DebugLog($error_msg);
            $sql_settings = SGAntiVirus_SQL_scanner::GetSQLsettings($detected_CMS);
            
            $error_msg = 'Read SQL records';
            if (self::$debug) self::DebugLog($error_msg);
            $sql_results = SGAntiVirus_SQL_scanner::ScanSQLContent($domain, $sql_settings, $detected_CMS);
            if ($sql_results['status'] === true)
            {
        		$file_sql_results = $this->tmp_dir.'report_sql_results.php';
        
        		$fp = fopen($file_sql_results, 'w');
        		$status = fwrite($fp, "<?php die(); ?>\n".json_encode($sql_results['results']));
        		fclose($fp);
                
                $error_msg = 'Detected: A='.count($sql_results['results']['A']).', IFRAME='.count($sql_results['results']['IFRAME']).', SCRIPT='.count($sql_results['results']['SCRIPT']);
                if (self::$debug) self::DebugLog($error_msg);
            }
            else {
                $error_msg = 'ScanSQLContent returned error: '.$sql_results['reason'];
                if (self::$debug) self::DebugLog($error_msg);
            }
            
            unlink($this->tmp_dir.'antivirus_sql.lock');
        }



         
		/**
		 * Analyze what way to use for packing
		 */
	 	$ssh_flag = false;
		if ( function_exists('exec') ) 
		{
			// Pack files with ssh 
			$ssh_flag = true;
		}
        if (defined('SETTINGS_ONLY_ZIP') && SETTINGS_ONLY_ZIP) $ssh_flag = false;
		
        
        if (self::$debug) self::DebugLog('line');
        


        
        $files_list = array();
        if (defined('DEBUG_FILELIST') && DEBUG_FILELIST) self::DebugFile($this->work_dir, true);
        
		$error_msg = 'Collecting info about the files [METHOD 2]';
		if (self::$debug) self::DebugLog($error_msg);        
        
        

        
        $this->exclude_folders_real = array();
        
        
        
        $dirList = array();
        $dirList[] = $scan_path;
        
        
 
                
        // Scan all dirs
        while (true) 
        {
            $dirList = array_merge(self::ScanFolder(array_shift($dirList), $files_list), $dirList);
            if (count($dirList) < 1) break;
        }
        
        
		$error_msg = 'Save collected file_list';
		if (self::$debug) self::DebugLog($error_msg);

		$collected_filelist = $this->tmp_dir.'filelist_'.md5($this->access_key).'.txt';

		$fp = fopen($collected_filelist, 'w');
		$status = fwrite($fp, implode("\n", $files_list));
		fclose($fp);
		if ($status === false)
		{
			$error_msg = 'Cant save information about the collected files '.$collected_filelist;
			if (self::$debug) self::DebugLog($error_msg);
			
			// Turn ZIP mode
			$ssh_flag = false;
		}
		
		$error_msg = 'Total files: '.count($files_list);
		if (self::$debug) self::DebugLog($error_msg);
         
        
        

        
        


        if (self::$debug) self::DebugLog('line');



	
		if ($ssh_flag)
		{
			// SSH way
				$error_msg = 'Start - Pack with SSH';
				if (self::$debug) self::DebugLog($error_msg);
				
			$cmd = 'cd '.$scan_path.''."\n".'tar -czf '.$this->tmp_dir.'pack_'.md5($this->access_key).'.tar -T '.$collected_filelist;
			$output = array();
			$result = exec($cmd, $output);
			
			if (file_exists($this->tmp_dir.'pack_'.md5($this->access_key).'.tar') === false || filesize($this->tmp_dir.'pack_'.md5($this->access_key).'.tar') < 512) 
			{
				$ssh_flag = false;
				
				$error_msg = 'Change pack method from SSH to PHP (ZipArchive)';
				if (self::$debug) self::DebugLog($error_msg);
                
				$error_msg = 'exec output: '.print_r($output, true);
				if (self::$debug) self::DebugLog($error_msg);
			}
		}
		
        
        
    	if (!$ssh_flag) 
    	{
    		// PHP way
    			$error_msg = 'Start - Pack with ZipArchive';
    			if (self::$debug) self::DebugLog($error_msg);
    		
    	    	$file_zip = $this->tmp_dir.'pack_'.md5($this->access_key).'.zip';
    	    	if (file_exists($file_zip)) unlink($file_zip);
    	    	$pack_dir = $scan_path;
                
                	
    	    if (class_exists('ZipArchive') && ( defined('DISABLE_ZIPARCHIVE') && DISABLE_ZIPARCHIVE === false ) )
    	    {
    	        // open archive
    	        $zip = new ZipArchive;
    	        if ($zip->open($file_zip, ZIPARCHIVE::CREATE | ZIPARCHIVE::OVERWRITE) === TRUE) 
    	        {
    	            foreach ($files_list as $file_name) 
    	            {
    	            	$file_name = $this->scan_path.$file_name;
    	                if( strstr(realpath($file_name), "stark") == FALSE) 
    					{
    						$short_key = str_replace($scan_path, "", $file_name);
    	                	$s = $zip->addFile(realpath($file_name), $short_key);
    		                if (!$s) 
    		                {
    		                	$error_msg = 'Couldnt add file: '.$file_name; 
    		                	if (self::$debug) self::DebugLog($error_msg);
    		                }
    	            	}
    					
    				}
    	             // close and save archive
    	            $zip->close();
    	            
    	            //$result['msg'][] = 'Archive created successfully'; 
    	        }
    	        else {
    	        	$error_msg = 'Error: Couldnt open ZIP archive.';
    	            self::UpdateProgressValue($current_task, $total_tasks, $error_msg);
    				if (self::$debug) self::DebugLog($error_msg);
    				exit;
    	        }
    	
    	    }
    	    else {
    	    	$error_msg =  'Error: ZipArchive class is not exist.';
    	        if (self::$debug) self::DebugLog($error_msg);
    	    }
    	    
    		$error_msg = 'ZipArchive method - finished';
    		if (self::$debug) self::DebugLog($error_msg);
    		
    		// Check if zip file exists
    		if (!file_exists($file_zip))
    		{
    			$error_msg = 'Error: zip file is not exists. Use OwnZipClass';
    			if (self::$debug) self::DebugLog($error_msg);
    			
    			$error_msg = 'OwnZipClass method - started';
    			if (self::$debug) self::DebugLog($error_msg);
                
    				$zip = new ZipSGAVP();
    				$zip->setZipFile($file_zip);
    	            foreach ($files_list as $file_name_short) 
    	            {
    	            	$file_name = trim($this->scan_path.$file_name_short);
						
							if (defined('DEBUG_ZIP_ADDFILES') && DEBUG_ZIP_ADDFILES === true)
							{
								$error_msg = 'Zip Add: '.$file_name;
								if (self::$debug) self::DebugLog($error_msg);
							}
							
    	            	$handle = fopen($file_name, "r");
    	            	if (filesize($file_name) > 0) $zip->addFile(fread($handle, filesize($file_name)), $file_name_short, filectime($file_name), NULL, TRUE, ZipSGAVP::getFileExtAttr($file_name));
    	            	fclose($handle);
    	           	}
    	           	$zip->finalize();
               	
    			$error_msg = 'OwnZipClass method - finished';
    			if (self::$debug) self::DebugLog($error_msg);
                
                $ssh_flag = false; 
    		}
    		
    	}
        
        


		/**
		 * Send files to SG server
		 */
		if ($ssh_flag)
		{
	 		$archive_filename = $this->tmp_dir.'pack_'.md5($this->access_key).'.tar';
	 		$archive_format = 'tar';
		} else {
			$archive_filename = $this->tmp_dir.'pack_'.md5($this->access_key).'.zip';
			$archive_format = 'zip';
		}
		$error_msg = 'Pack file: '.$archive_filename;
		if (self::$debug) self::DebugLog($error_msg);

		
	 	
	 	// Check if pack file is exist
		if (file_exists($archive_filename) === false) 
		{
			$error_msg = 'Error: Pack file is not exist. Probably not enough space on the server.';
			if (self::$debug) self::DebugLog($error_msg);
			echo $error_msg;
			exit;
		}
        
		$tar_size = filesize($archive_filename);
		$error_msg = 'Pack file is '.round($tar_size/1024/1024, 2).'Mb';
		if (self::$debug) self::DebugLog($error_msg);
        
        
        
        if (self::$debug) self::DebugLog('line');
		
		
		
		$error_msg = 'Start - Send Packed files to SG server';
		if (self::$debug) self::DebugLog($error_msg);
		
        $archive_file_url = "/".str_replace($this->scan_path, "", $this->tmp_dir).'pack_'.md5($this->access_key).'.'.$archive_format;
        $archive_file_url = str_replace("\\", "/", $archive_file_url);
		$error_msg = 'Pack URL: '.$archive_file_url;
		if (self::$debug) self::DebugLog($error_msg);
		
		if ($tar_size < 256 * 1024 * 1024 || $membership == 'pro')
    	{
    		// Send file
    		$post_data = base64_encode(json_encode(array(
    				'domain' => $domain,
    				'access_key' => $access_key,
    				'email' => $email,
    				'product_type' => ANTIVIRUS_PLATFORM,
    				'session_report_key' => $session_report_key,
    				'archive_format' => $archive_format,
    				'archive_file_url' => $archive_file_url))
    		);
            
            
            $result = self::UploadSingleFile($archive_filename, 'uploadfiles_ver2', $post_data);
			if ($result === false) $error_msg = 'Can not upload pack file for analyze';
            else $error_msg = 'OK - Pack file uploaded for analyze';
			if (self::$debug) self::DebugLog($error_msg);
            
            if ($result === false) die();
    
    		
    	}
		else {
			$error_msg = 'Pack file is too big ('.$error_msg.'), please contact SiteGuarding.com support or upgrade to PRO version.';
			if (self::$debug) self::DebugLog($error_msg);
			echo $error_msg;
            $error_msg = 'Website is huge or hosting account has other sites. Free version has limits. Contact SiteGuarding.com support.';
            self::ErrorLog($error_msg);
			exit;
		}


        if (self::$debug) self::DebugLog('line');
        
		echo '<br><div style="visibility: hidden; text-align: center;" id="report_link"><a target="_blank" href="https://www.siteguarding.com/antivirus/viewreport?refresh=1&report_id='. $session_report_key .'"><button class="btn btn-primary"> Click to see latest report</button></a></div>';
		
		$error_msg = 'Finished'."\n" . "<br>";
		if (self::$debug) self::DebugLog($error_msg);
        
		// Remove logs
        unlink($this->tmp_dir.'debug_'.md5($access_key).'.log');
        unlink($this->tmp_dir.'filelist_'.md5($access_key).'.txt');
        if (file_exists($this->tmp_dir.'pack_'.md5($access_key).'.zip')) unlink($this->tmp_dir.'pack_'.md5($access_key).'.zip');
        if (file_exists($this->tmp_dir.'pack_'.md5($access_key).'.tar')) unlink($this->tmp_dir.'pack_'.md5($access_key).'.tar');
		if (file_exists($this->tmp_dir.'filelist.txt')) unlink($this->tmp_dir.'filelist.txt');
		if (file_exists($this->tmp_dir.'debug.log')) unlink($this->tmp_dir.'debug.log');
		if (file_exists($this->tmp_dir.'pack.zip')) unlink($this->tmp_dir.'pack.zip');
		if (file_exists($this->tmp_dir.'pack.tar')) unlink($this->tmp_dir.'pack.tar');
		if (file_exists($this->tmp_dir.'report_excluded_folders.php')) unlink($this->tmp_dir.'report_excluded_folders.php');
		if (file_exists($this->tmp_dir.'report_excluded_files.php')) unlink($this->tmp_dir.'report_excluded_files.php');
		if (file_exists($this->tmp_dir.'report_notreadable_files.php')) unlink($this->tmp_dir.'report_notreadable_files.php');
		if (file_exists($this->tmp_dir.'antivirus_error.log')) unlink($this->tmp_dir.'antivirus_error.log');
		if (file_exists($this->tmp_dir.'report_sql_results.php')) unlink($this->tmp_dir.'report_sql_results.php');
		if (file_exists($this->tmp_dir.'flag_terminated.tmp')) unlink($this->tmp_dir.'flag_terminated.tmp');
		if (file_exists($this->tmp_dir.'antivirus_scan.lock')) unlink($this->tmp_dir.'antivirus_scan.lock');
		
    }
    
    
    
    
    
    function ScanFolder($path, &$files_list)
    {
        $dirList = array();
    
        if ($currentDir = opendir($path)) 
        {
            while ($file = readdir($currentDir)) 
            {
                if ( $file === '.' || $file === '..' || is_link($path) ) continue;
                $file = $path . '/' . $file;
    
                
                if (is_dir($file)) 
                {
                    $folder = $file.DIRSEP;
                    $folder = str_replace(DIRSEP.DIRSEP, DIRSEP, $folder);
                    
                    // Exclude folders
                    if (count($this->exclude_folders_real))
                    {
                 		if (in_array($folder, $this->exclude_folders_real)) 
        				{
        				    if (self::$debug) self::DebugLog('--- '.$folder);
                            continue;
        				}
        				else if (self::$debug) self::DebugLog('+++ '.$folder);
                    }
                    $dirList[] = $file;
                    if (defined('DEBUG_FILELIST') && DEBUG_FILELIST) self::DebugFile($file);
                }
                else {
                    
                    if (is_link($file))
                    {
                        self::DebugLog('Symbolic link: '.$file);
                        continue;
                    }
                    
					//if (strpos($file, '.php.') || strpos($file, '.phtml.') || strpos($file, '.php3.') || strpos($file, '.php4.') || strpos($file, '.php5.'))
					if (strpos($file, '.php') || strpos($file, '.phtml'))
					{
					    $file_size = filesize($file);
                        if ($file_size > self::$max_filesize)
                        {
                            if (self::$debug) self::DebugLog('Big file: '.str_replace($this->scan_path, "", $file).' ['.$file_size.' bytes]');
                            self::HugeFilesLog(str_replace($this->scan_path, "", $file));
                            continue;
                        }
                        
                        $ext = strtolower(pathinfo($file, PATHINFO_EXTENSION));
                        switch ($ext)
                        {
                            case 'tar':
                            case '7z':
                            case 'exe':
                            case 'gz':
                            case 'gzip':
                            case 'pak':
                            case 'pkg':
                            case 'rar':
                            case 'tar-gz':
                            case 'tgz':
                            case 'zip':
                                self::DebugLog('Excluded ext: '.$file);
                                continue;
                        }
                        
                        if (!is_readable($file))
                        {
                            self::DebugLog('NOT readable: '.$file);
                            self::NotReadableFilesLog(str_replace($this->scan_path, "", $file));
                            continue;
                        }
                        
                        if (strlen($this->scan_path) > 1) $file = str_replace($this->scan_path, "", $file);
        				if ($file[0] == "\\" || $file[0] == "/") $file[0] = "";
        				$file = trim($file);
        				$files_list[] = $file;
					}
					else {
                        // Check extension
                        $ext = strtolower(pathinfo($file, PATHINFO_EXTENSION));
                        switch ($ext)
                        {
                            case 'ico':
                            
                            case 'inc':
                            case 'php':
                            case 'php4':
                            case 'php5':
                            case 'phtml':
                            case 'js':
                            case 'html':
                            case 'htm':
                            case 'cgi':
                            case 'pl':
                            case 'so':
                            case 'sh':
                            case 'htaccess':
                            
        					    $file_size = filesize($file);
                                if ($file_size > self::$max_filesize)
                                {
                                    if (self::$debug) self::DebugLog('Big file: '.str_replace($this->scan_path, "", $file).' ['.$file_size.' bytes]');
                                    self::HugeFilesLog(str_replace($this->scan_path, "", $file));
                                    continue;
                                }
                                
                                if (!is_readable($file))
                                {
                                    self::DebugLog('NOT readable: '.$file);
                                    self::NotReadableFilesLog(str_replace($this->scan_path, "", $file));
                                    continue;
                                }
                                
                                if (strlen($this->scan_path) > 1) $file = str_replace($this->scan_path, "", $file);
                				if ($file[0] == "\\" || $file[0] == "/") $file[0] = "";
                				$file = trim($file);
                				$files_list[] = $file;
                                break;
                                
                            
                            default:
                                if (FULL_SCAN)
                                {
            					    $file_size = filesize($file);
                                    if ($file_size > self::$max_filesize) continue;
                                    
                                    $handle = fopen($file, "r");
                                    $contents = fread($handle, 5);
                                    fclose($handle);
                                    
                                    if ($contents == '<?php')
                                    {
                                        if (strlen($this->scan_path) > 1) $file = str_replace($this->scan_path, "", $file);
                        				if ($file[0] == "\\" || $file[0] == "/") $file[0] = "";
                        				$file = trim($file);
                        				$files_list[] = $file;
                                        
                                        self::DebugLog('*PHP code detected: '.str_replace($this->scan_path, "", $file).' ['.$file_size.' bytes]');
                                    }
                                }

                        }
                    }
                    
                }
    
            }
            closedir($currentDir);
        }
    
        return $dirList;
    }

    

    
    
    
    function DebugFile($file, $clean_log_file = false)
    {
		if ($clean_log_file) $fp = fopen($this->tmp_dir.'debug_filelist.log', 'w');
		else {
            $file = str_replace($this->scan_path, "", $file);
    	    $fp = fopen($this->tmp_dir.'debug_filelist.log', 'a');
		}

		$a = $file."\n";
		fwrite($fp, $a);
		fclose($fp); 
    }
    
    

    
    
    
    function UploadSingleFile($file, $action, $post_data)
    {
        $status = self::UploadSingleFile_extension($file, $action, $post_data);
        if ($status === false) $status = self::UploadSingleFile_extension($file, $action, $post_data, true);
        
        return $status;
    }
    
    
    function UploadSingleFile_extension($file, $action, $post_data, $https_flag = false)
    {
    	$target_url = self::$SITEGUARDING_SERVER;
        if ($https_flag === true) $target_url = str_replace("http://www.", "https://www.", $target_url);
    	$target_url = $target_url.'?action='.$action;
        
    	$file_name_with_full_path = $file;
        
        if (class_exists('CurlFile'))
        {
    		$error_msg = 'CURLOPT: CurlFile';
    		if (self::$debug) self::DebugLog($error_msg);
            
        	$post = array(
        		'data' => $post_data,
        		'file_contents' => new CurlFile($file_name_with_full_path)
        	);
        }
        else {
    		$error_msg = 'CURLOPT: @file';
    		if (self::$debug) self::DebugLog($error_msg);
            
        	$post = array(
        		'data' => $post_data,
        		'file_contents' => '@'.$file_name_with_full_path
        	);
        }
    	
    		$error_msg = 'CURL CURLOPT_INFILE: '.$file_name_with_full_path;
    		if (self::$debug) self::DebugLog($error_msg);
    		$error_msg = 'CURL CURLOPT_INFILESIZE: '.filesize($file_name_with_full_path);
    		if (self::$debug) self::DebugLog($error_msg);
    		$error_msg = 'Use HTTPS: '.self::$bool_list[intval($https_flag)];
    		if (self::$debug) self::DebugLog($error_msg);
    		
    
     	$ch = curl_init();
    	curl_setopt($ch, CURLOPT_URL,$target_url);
    	curl_setopt($ch, CURLOPT_POST,1);
        curl_setopt($ch, CURLOPT_SAFE_UPLOAD,false);
    	curl_setopt($ch, CURLOPT_POSTFIELDS, $post);
    	curl_setopt($ch, CURLOPT_INFILE, $file_name_with_full_path);
    	curl_setopt($ch, CURLOPT_INFILESIZE, filesize($file_name_with_full_path));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        
    	$result=curl_exec ($ch);
        
    		$info = curl_getinfo($ch);
    		//$error_msg = 'CURL info - '.print_r($info, true);
    		//if (self::$debug) self::DebugLog($error_msg);
    		
    	$curl_error = curl_error($ch);
    	curl_close ($ch);
        
    		$error_msg = 'CURL result: '.$result;
    		if (self::$debug) self::DebugLog($error_msg);
    	
    	if ($info['size_upload'] < 10000/*filesize($file_name_with_full_path)*/)
    	{
    		$error_msg = 'CURL uploaded file wrong size: '.$info['size_upload'];
    		if (self::$debug) self::DebugLog($error_msg);
    		
    		return false;
    	}
    
        if (json_decode($result, true) == NULL)
        {
            return false;
        }
        else return true;
    }
    
    

	
    
    
	public function DebugLog($txt, $clean_log_file = false)
	{
	    if ($txt == 'line') $txt = '-----------------------------------------------------------------------';
		if ($clean_log_file) $fp = fopen($this->tmp_dir.'debug_'.md5($this->access_key).'.log', 'w');
		else $fp = fopen($this->tmp_dir.'debug_'.md5($this->access_key).'.log', 'a');
		$a = date("Y-m-d H:i:s")." ".$txt."\n";
        echo $a . "</br>";
		fwrite($fp, $a);
		fclose($fp);
	}
    
	public function HugeFilesLog($txt)
	{
        $file = $this->tmp_dir.'report_excluded_files.php';
        if (!file_exists($file)) $txt = "<?php die(); ?>\n".$txt;
	    $fp = fopen($file, 'a');
		fwrite($fp, $txt."\n");
		fclose($fp);
	}
    
    
	public function NotReadableFilesLog($txt)
	{
        $file = $this->tmp_dir.'report_notreadable_files.php';
        if (!file_exists($file)) $txt = "<?php die(); ?>\n".$txt;
	    $fp = fopen($file, 'a');
		fwrite($fp, $txt."\n");
		fclose($fp);
	}
    
	public function ErrorLog($txt)
	{
	    $fp = fopen($this->tmp_dir.'antivirus_error.log', 'w');
		$a = date("Y-m-d H:i:s")." ".$txt."\n";
		fwrite($fp, $a);
		fclose($fp);
	}
}