<?php
require_once "/usr/local/cpanel/php/cpanel.php";
$cpanel = new CPANEL();

print $cpanel->header( "Website Antivirus Scanner", "website_antivirus_scanner" );

require_once "cpanel_config.php";
require_once "/usr/local/cpanel/whostmgr/docroot/cgi/siteguarding_antivirus_scanner/config.php";
require_once "classes/SGAV_html_parser.php";
require_once "classes/SGAntiVirus_SQL_scanner.php";
require_once "classes/ZipSGAVP.php";
require_once "classes/SGAntiVirus_scanner.php";
require_once "functions.php";

date_default_timezone_set('Europe/London');
ini_set('max_execution_time',7200);
set_time_limit ( 7200 );
ini_set('post_max_size', '256M');
ini_set('upload_max_filesize', '256M');
ini_set('memory_limit', '512M');
ignore_user_abort(true);

if(isset($_GET['scan_path']) && !empty($_GET['scan_path'])) {
    $scan_path = $_GET['scan_path'];
}

if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {	
        define('DIRSEP', '\\');
        $scan_path = $scan_path.DIRSEP;
    }
    else {
        define('DIRSEP', '/');
        $scan_path = DIRSEP.$scan_path.DIRSEP;
}

$scan_path = str_replace( DIRSEP.DIRSEP, DIRSEP, $scan_path );
define('SCAN_PATH', $scan_path);

define('REPORT_EMAIL', '');

$get_userdata = $cpanel->uapi(
    'DomainInfo', 'domains_data',
    array(
        'format'    => 'hash',
    )
);

if(isset($_GET['task']) && $_GET['task'] === "scan") {
	?>
	<div style="width: 100%; background-color: grey; ">
		<div id="myBar" style="width: 1%;height: 30px; background-color: #4CAF50;text-align: center;line-height: 30px;color: white; ">1%</div>
	</div>
	<script type="text/javascript">
		var elem = document.getElementById("myBar"); 
		var width = 1;
		var id = setInterval(frame, 12000);
		function frame() {
				width += getRndInteger(6,10); 
				if(width >= 100){
					width = 100;
					clearInterval(id);
					var rep_elem = document.getElementById("report_link");
					if(rep_elem == null){
					document.getElementById("scan_error").style.visibility = 'visible';
				} else {
					rep_elem.style.visibility = 'visible';
				}
				}
				elem.style.width = width + '%'; 
				elem.innerHTML = width * 1  + '%';
		}
		
		function getRndInteger(min, max) {
			return Math.floor(Math.random() * (max - min)) + min;
		}
	</script>
	<br>
	<div style="visibility: hidden;text-align: center;" id="scan_error">Cant find latest report. Please contact to support team.</div>
	<?php
    scan();
    exit;
}

?>
<link rel="stylesheet" href="css/semantic.min.css">
<link rel="stylesheet" href="css/main.css">
<script type="text/javascript" src="js/main.js"></script>
<div class="ui grid">
	<div class="eight wide column">
		<div class="ui bulleted list">
			<h3 class="ui header">Here is the list of malware types what our scanner can detect:</h3>
			<div class="item"><b>MySQL and JavaScript injections</b></div>
			<div class="item"><b>Website Defacements</b></div>
			<div class="item"><b>Hidden iFrames</b></div>
			<div class="item"><b>PHP Mailers</b></div>
			<div class="item"><b>Social Engineering Attacks</b></div>
			<div class="item"><b>Phishing Page Detection</b></div>
			<div class="item"><b>Redirects</b></div>
			<div class="item"><b>Website Backdoors</b></div>
			<div class="item"><b>Website Anomalies</b></div>
			<div class="item"><b>Drive-by-Downloads</b></div>
			<div class="item"><b>IP Cloaking</b></div>
			<div class="item"><b>Cross Site Scripting (XSS)</b></div>
			<div class="item"><b>.htaccess</b></div>
		</div>
	</div>
	<div class="eight wide column">
		<div class="ui centered grid">
			<div class="row">
				<img src="images/<?php echo LOGO_NAME; ?>"/>
			</div>
			<div class="row">
				<p>
					Our security experts and engineers are more than happy to help you find and remove any malware and backdoors from your website. They will fix all the bugs your website might have to prevent future hackers attacks.
				</p>
				<p>
					<a href="<?php echo CLEAN_URL; ?>" target="_blank">
						<button class="ui blue button">Clean My Website</button>
					</a>
				</p>
			</div>
			<div class="row">
				<p>
					We control the security of your website. If any issue or unusual activity is detected, we automatically login and fix the issue. Your website will be under 24/7/365 monitoring to keep your business & website clean, safe and secure.
				</p>
				<p>
					<a href="<?php echo PROTECT_URL; ?>" target="_blank">
					<button class="ui blue button">Protect My Website</button>
					</a>
				</p>	
			</div>
		</div>
	</div>
	<table class="ui celled padded table" id="general">
	<caption><h1 class="ui header">List of domains</h1></caption>
	<thead>
		<tr>
			<th>Domain</th>
			<th>Type</th>
			<th>Document Root</th>
			<th>Actions</th>
		</tr>
	</thead>
	<tbody>
	<?php 
	print create_domain_content($get_userdata["cpanelresult"]["result"]["data"]["main_domain"],'main'); 
	print create_domain_content($get_userdata["cpanelresult"]["result"]["data"]["sub_domains"]); 
	print create_domain_content($get_userdata["cpanelresult"]["result"]["data"]["addon_domains"]); 
	print create_domain_content($get_userdata["cpanelresult"]["result"]["data"]["parked_domains"]);
	?>
	</tbody>
	</table>
	<br>
</div>

<?php
print $cpanel->footer();
$cpanel->end();
?>